/*+------------------------------------------------------------------+
   Version 1.0, Author: Aiman
   Description: Indicator Account (IA)
   - Special Thank you to TeMPe for his sort decending sample code
   
   Version 1.1 (29.09.2009) Edited by Aiman
   - Price open & close has been removed
   - Cannot put 2 same date at setting -  FIXED
   - 3 Horizontal lines added
   - Total Spread value in PIPS & USD added
   - Option to select simulation 28 pairs or 14 pairs
   
   Version 1.2 (29.09.2009) Edited by Aiman
   - Selection set for 14 pairs simulation has been amended
   
   Version 1.3 (20.10.2009) Edited by Aiman
   - Percent changed & average percent changed added
   - (-) sign removed, red(Peru) represent negative value
   - AutoTimer added
   - Option for Accending or Decending Order has been Added
   
   Version 1.4 (27.10.2009) Edited by Aiman
   - Anchor Pairs added in user input (for different Pair colour purpose)
   - AutoTimer sequence has been changed from left to right
   - The indicator is now has been converted to expert to prevent lagging
//+------------------------------------------------------------------+*/
#property copyright "Copyright  2009, 1000 pips club."
#property link      "www.oasiswealthbuilders.com"
#property show_inputs 
//+------------------------------------------------------------------+
//|Type Of Trade                                                     |
//|1=Buy Only, 2=Sell Only                                           |
//+------------------------------------------------------------------+
extern int     tradetype      =1;
extern double  Lots           =0.1;
extern bool    Accending      =true;
//+------------------------------------------------------------------+
//|Simulation Setting                                                |
//|1=28 Pairs, 2=14 Pairs                                            |
//+------------------------------------------------------------------+
extern int     Simulation     =1;
//+------------------------------------------------------------------+
//|Candle period will not be used is autotimer is ON                 |
//|Candle Period Setting (time frame)                                |
//|5=M5, 15=M15, 30=M30, 60=H1, 240=H4, 1440=D1                      |
//+------------------------------------------------------------------+
extern int     CandlePeriod   =30;
//+------------------------------------------------------------------+
//|AutoTimer Setting                                                 |
//|0=Manual, 1=W1, 2=D1, 3=H4", 4=H1"                                |
//+------------------------------------------------------------------+
extern   int    AutoTimer     =5;
extern   string AnchorPair    ="GBPUSD,GBPJPY,EURJPY,";
extern   string timer1        ="2009.9.28 00:00";
extern   string timer2        ="2009.9.28 04:00";
extern   string timer3        ="2009.9.28 08:00";
extern   string timer4        ="2009.9.28 12:00";
extern   string info1         ="======8 timer for simulation2 only======";
extern   string timer5        ="2009.9.28 00:00";
extern   string timer6        ="2009.9.28 04:00";
extern   string timer7        ="2009.9.28 08:00";
extern   string timer8        ="2009.9.28 12:00";
extern string ccy            = "JPY";

string   iPairs[28] ={"EURUSD", "GBPUSD", "AUDUSD", "USDJPY", "USDCHF", "USDCAD", "EURAUD",
                      "EURCAD", "EURCHF", "EURGBP", "EURJPY", "GBPJPY", "GBPCHF", "NZDUSD",
                      "AUDCAD", "AUDJPY", "CHFJPY", "AUDNZD", "NZDJPY", "NZDCAD", "NZDCHF",
                      "GBPNZD", "EURNZD", "GBPCAD", "GBPAUD", "AUDCHF", "CADCHF", "CADJPY"};        
                      
string   jPairs[14] ={"USDCHF", "EURGBP", "GBPUSD", "NZDUSD", "EURJPY", "AUDJPY", "GBPJPY",              
                      "AUDUSD", "NZDJPY", "CHFJPY", "USDJPY", "EURUSD", "EURCHF", "GBPCHF"};
string   bPairs[7] ={"USDCHF", "EURGBP", "NZDUSD", "GBPUSD", "EURJPY", "AUDJPY", "GBPJPY"};             
                                  
string   sPairs[7] ={"AUDUSD", "NZDJPY", "CHFJPY", "USDJPY", "EURUSD", "EURCHF", "GBPCHF"};                                                        
            
string   suffix, TimerText, symbol[28], anchor[];
int      xdist, ydist;
double   openbuy[28], closebuy[28], opensell[28], closesell[28], pipsbuy[28], pipssell[28],
         profitbuy[28], profitsell[28], spread[28];

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init() 
{
   AnchorPair = StringUpperCase(StringTrimLeft(StringTrimRight(AnchorPair)));
   if (StringSubstr(AnchorPair,StringLen(AnchorPair),1) != ",")
                    AnchorPair = StringConcatenate(AnchorPair,",");
   int  s = 0;
   int  i = StringFind(AnchorPair,",",s);
   string current;
   while (i > 0)
   {
      current = StringSubstr(AnchorPair,s,i-s);
      ArrayResize(anchor,ArraySize(anchor)+1);
      anchor[ArraySize(anchor)-1] = current;
      s = i + 1;
      i = StringFind(AnchorPair,",",s);
   }
   if (Simulation==2)
   {
      ArrayResize (iPairs, ArraySize(jPairs));
      for (i=0; i<ArraySize(jPairs);i++)
         iPairs[i] = jPairs[i];
   }
    

   suffix=StringSubstr(Symbol(),6,1);
   
   ObjectsDeleteAll(); 
   Comment(""); 
   return(0);
}
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit() {ObjectsDeleteAll(); return(0);}
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
   string trademode, time;
   
   while(!IsStopped())
   {
      RefreshRates();   
      if (tradetype==1) trademode=" - Buy all pairs";
      if (tradetype==2) trademode=" - Sell all pairs";
      time=StringConcatenate("Current Broker Time= ", 
                              TimeToStr(TimeCurrent(), 
                              TIME_DATE)," (", TimeToStr(TimeCurrent(), 
                              TIME_MINUTES), ")", trademode);
                              
                   
                           
      drawLabel("CurrentTime", time, 10, "Courier New", Yellow, 0, 10, 10); 
      drawLabel("TimerText", TimerText, 9, "Courier New", Gray, 0, 10, 22);     
      drawLabel("Copyright", "1000pips Club  www.oasiswealthbuilders.com", 8, "Arial", Yellow, 1, 10, 10); 
      //ObjectSet("Copyright", OBJPROP_ANGLE, 90);
      //---------------------add
      TimerText="Manual";
   if (AutoTimer==1) { TimerText="Weekly Auto"; CandlePeriod=10080; }
   if (AutoTimer==2) { TimerText="Daily Auto"; CandlePeriod=1440; }
   if (AutoTimer==3) { TimerText="H4 Auto"; CandlePeriod=240; }
   if (AutoTimer==4) { TimerText="H1 Auto"; CandlePeriod=60; }
   if (AutoTimer!=0)
   {
      timer1=TimeToStr(iTime(Symbol(), CandlePeriod, 3));
      timer2=TimeToStr(iTime(Symbol(), CandlePeriod, 2));
      timer3=TimeToStr(iTime(Symbol(), CandlePeriod, 1));
      timer4=TimeToStr(iTime(Symbol(), CandlePeriod, 0));
      timer5=TimeToStr(iTime(Symbol(), CandlePeriod, 7));
      timer6=TimeToStr(iTime(Symbol(), CandlePeriod, 6));
      timer7=TimeToStr(iTime(Symbol(), CandlePeriod, 5));
      timer8=TimeToStr(iTime(Symbol(), CandlePeriod, 4));      
   }   
    
    if (AutoTimer==5) 
   { 
      TimerText="Multiple TimeFrames: Weekly, Daily, H4, H1, M15"; 
      timer1=TimeToStr(iTime(Symbol(), 10080, 1));
      timer2=TimeToStr(iTime(Symbol(), 1440, 0));
      timer3=TimeToStr(iTime(Symbol(), 240, 0));
      timer4=TimeToStr(iTime(Symbol(), 60, 0));
      timer5=TimeToStr(iTime(Symbol(), 15, 0)); // mizee add tf15
   }
   
   
      //---------------------add
      
      int column=10;
      int nextcolumn=220;
      //if (AutoTimer==5) CandlePeriod=10080;
      
      
      if (AutoTimer==5)
      {
      if (AutoTimer==5) CandlePeriod=10080;
      display_IA(StrToTime(timer1), column, 60);  
      column = column+nextcolumn;      
      if (AutoTimer==5) CandlePeriod=60;
      display_IA(StrToTime(timer2), column, 60);
      column = column+nextcolumn;
      if (AutoTimer==5) CandlePeriod=60;
      display_IA(StrToTime(timer3), column, 60);    
      column = column+nextcolumn;
      if (AutoTimer==5) CandlePeriod=60;
      display_IA(StrToTime(timer4), column, 60);  
      
     if (AutoTimer==5) 
     {
     CandlePeriod=15;      // mizee add
      
      column = column+nextcolumn;
      display_IA(StrToTime(timer5), column, 60);     // mizee add TFm15
     } 
      }
      if ((AutoTimer==1) || (AutoTimer==2) || (AutoTimer==3) || (AutoTimer==4))
      {
      display_IA(StrToTime(timer4), column, 60);  
      column = column+nextcolumn;      
      //if (AutoTimer==5) CandlePeriod=60;
      display_IA(StrToTime(timer3), column, 60);
      column = column+nextcolumn;
      display_IA(StrToTime(timer2), column, 60);    
      column = column+nextcolumn;
      display_IA(StrToTime(timer1), column, 60); 
      }
      if (Simulation==2)
      {
         column=10;
         nextcolumn=220;
         display_IA(StrToTime(timer5), column, 281);  
         column = column+nextcolumn;      
         display_IA(StrToTime(timer6), column, 281);
         column = column+nextcolumn;
         display_IA(StrToTime(timer7), column, 281);    
         column = column+nextcolumn;
         display_IA(StrToTime(timer8), column, 281);         
      }
    
      datetime perc_timer;
      column=480;
      nextcolumn=15;
      perc_timer=iTime(Symbol(), 43200, 0);
      PercentChange("Average Monthly % Change (from "+TimeToStr (perc_timer, TIME_DATE)+"):", PERIOD_D1, perc_timer, column);
      column = column-nextcolumn;
      perc_timer=iTime(Symbol(), 10080, 0);
      PercentChange("Average Weekly % Change  (from "+TimeToStr (perc_timer, TIME_DATE)+"):", PERIOD_D1, perc_timer, column);    
      column = column-nextcolumn;
      perc_timer=iTime(Symbol(), 1440, 0);
      PercentChange("Average Daily % Change   (from "+TimeToStr (perc_timer, TIME_MINUTES)+")     :", PERIOD_H1, perc_timer, column);    
      column = column-nextcolumn;    
      perc_timer=iTime(Symbol(), 240, 0);
      PercentChange("Average H4 % Change      (from "+TimeToStr (perc_timer, TIME_MINUTES)+")     :", PERIOD_H1, perc_timer, column);
      //ObjectsRedraw();
      WindowRedraw();
      Sleep(1000);
   }

    return (0);
  }
//+------------------------------------------------------------------+   
void display_IA (datetime timer, int xdistt, int ydistt)
{
   double open, close, profit, pips, totalpips, totalprofit, spreadpips, spreadcurr;
   string textnames, textname, texttitle, time;
   textnames="IA";
   datetime date, temdate;
   color PipsColor, SymColor;
 
   ydist=ydistt;
   int ystatusdist=ydist-14;
   
   totalprofit=0;
   spreadpips=0;
   spreadcurr=0;
   totalpips=0;
   for(int i=0; i<ArraySize(iPairs); i++)
   {
      string Sym        =StringConcatenate(iPairs[i],suffix);
      double point      =MarketInfo(Sym, MODE_POINT);
      double tickvalue  =MarketInfo(Sym, MODE_TICKVALUE);
      int Shift         =iBarShift(Sym, CandlePeriod, timer);

      spread[i]    =MarketInfo(Sym, MODE_SPREAD);
      symbol[i]    =Sym;
      openbuy[i]   =iOpen(Sym, CandlePeriod, Shift)+(spread[i]*point);
      closebuy[i]  =MarketInfo(Sym, MODE_BID);
      opensell[i]  =iOpen(Sym, CandlePeriod, Shift);
      closesell[i] =MarketInfo(Sym, MODE_ASK);
      pipsbuy[i]   =(closebuy[i]-openbuy[i])/point;
      pipssell[i]  =(opensell[i]-closesell[i])/point;
      profitbuy[i] =pipsbuy[i]*tickvalue*Lots;      
      profitsell[i]=pipssell[i]*tickvalue*Lots;
      if (tradetype==1)  
      {
         totalprofit=totalprofit+profitbuy[i];
         totalpips  =totalpips+ pipsbuy[i];
      }
      if (tradetype==2)
      {
         totalprofit=totalprofit+profitsell[i];  
         totalpips  =totalpips+ pipssell[i];
      }
      spreadpips=spreadpips+spread[i];
      spreadcurr=spreadcurr+(spread[i]*MarketInfo(Sym, MODE_TICKVALUE)*Lots);
  
   }
 
   for(i=0;i<ArraySize(iPairs);i++)
   for(int j=i;j<ArraySize(iPairs);j++)
   {
      if (!Accending)
      {
         if((tradetype==1 && profitbuy[j]<profitbuy[i]) || (tradetype==2 && profitsell[j]<profitsell[i]))
            sequence(i, j);
      }
      else
         if((tradetype==1 && profitbuy[j]>profitbuy[i]) || (tradetype==2 && profitsell[j]>profitsell[i]))
            sequence(i, j);
   } 
 
   date=0;
   for(i=0;i<ArraySize(symbol);i++)
   {
      Sym       =StringConcatenate(iPairs[i],suffix);
      temdate   =iTime(Sym, CandlePeriod, Shift);
      if(temdate>date) date=temdate;
      if (TimeToStr(temdate, TIME_DATE)!=TimeToStr(timer, TIME_DATE))
      {
         pipsbuy[i]=0;
         pipssell[i]=0;
         profitbuy[i]=0;
         profitsell[i]=0;
      }
   }
   xdist=xdistt;
   time=StringConcatenate(TimeToStr(date, TIME_DATE), " (", TimeToStr(date,TIME_MINUTES), ")" ) ;
   textname=StringConcatenate(textnames, "Date", DoubleToStr(xdistt+ydistt, 0));
   drawLabel(textname, time, 9, "Courier New", Ivory, 0, xdist, ystatusdist-12);  

   textname=StringConcatenate(textnames, "Title", DoubleToStr(xdistt+ydistt, 0) );
   drawLabel(textname, "Symbol  Spr Pips  Profit  %", 9, "Courier New", Yellow, 0, xdist, ystatusdist);   
   
   for(i=0; i<ArraySize(iPairs); i++)
   {
      if (tradetype==1)
      {
         open=openbuy[i];
         close=closebuy[i];
         pips=pipsbuy[i];
         profit=profitbuy[i];
      }
      if (tradetype==2)
      {
         open=opensell[i];
         close=closesell[i];
         pips=pipssell[i];
         profit=profitsell[i];
      }

      Sym       =StringConcatenate(symbol[i],suffix);
      int digit =MarketInfo(Sym, MODE_DIGITS); 
      xdist     =xdistt;
      SymColor  =Gainsboro;
      if (StringFind(symbol[i],ccy,0)!=-1) SymColor=Olive;
//      if (StringFind(symbol[i],"EUR",0)!=-1) SymColor=LightSalmon;
      
      for (int k=0;k<ArraySize(anchor);k++)
         if (StringSubstr(symbol[i],0,6)==anchor[k]) SymColor=DodgerBlue;
         
      textname  =StringConcatenate(textnames, symbol[i], DoubleToStr(xdistt+ydistt, 0) );
      drawLabel(textname, symbol[i], 10, "Courier New", SymColor, 0, xdist, ydist);   

      if (Simulation==1)
      {
         for(j=0;j<ArraySize(bPairs);j++)
         {
            if (StringSubstr(bPairs[j],0,6)==StringSubstr(symbol[i],0,6))
            {
               textname=StringConcatenate(textnames, symbol[i], "Mark", DoubleToStr(xdistt+ydistt, 0) );
               drawLabel(textname, "l", 8, "Wingdings", Chartreuse, 0, xdist+50, ydist+3);
            }
         }
         
         for(j=0;j<ArraySize(sPairs);j++)
         {
            if (StringSubstr(sPairs[j],0,6)==StringSubstr(symbol[i],0,6))
            {
               textname=StringConcatenate(textnames, symbol[i], "Mark", DoubleToStr(xdistt+ydistt, 0) );
               drawLabel(textname, "l", 8, "Wingdings", Coral, 0, xdist+50, ydist+3);
            }
         }
      }      
  
      string textspread, textpips, textprofit, textperc;
      if (pipsbuy[i]==0 && pipssell[i]==0 && profitbuy[i]==0 && profitsell[i]==0)
      {
         textspread="ERROR READING HISTORY";
         textpips="";
         textprofit="";
      }
      else
      {
         textspread=DoubleToStr(spread[i],0);
         textpips=DoubleToStr(MathAbs(pips),0);
         textprofit=DoubleToStr(MathAbs(profit),2);
      }
         
      xdist=xdist+60;
      textname=StringConcatenate(textnames, symbol[i], "Spread", DoubleToStr(xdistt+ydistt, 0) );
      drawLabel(textname, textspread, 8, "Courier New", DarkGray, 0, xdist, ydist);  
            
      xdist=xdist+30;
      textname=StringConcatenate(textnames, symbol[i], "Pips", DoubleToStr(xdistt+ydistt, 0) );
      drawLabel(textname, textpips, 9, "Courier New", statcolor (pips), 0, xdist, ydist);      
   
      xdist=xdist+40;   
      textname=StringConcatenate(textnames, symbol[i], "Profit", DoubleToStr(xdistt+ydistt, 0) );
      drawLabel(textname, textprofit, 9, "Courier New", statcolor (profit), 0, xdist, ydist);  
  
      xdist=xdist+50;   
      double perc;
      if (tradetype==1) perc = ((closebuy[i]-openbuy[i])/openbuy[i])*100;
      if (tradetype==2) perc = ((closesell[i]-opensell[i])/opensell[i])*100; 
      textperc = DoubleToStr(MathAbs(perc),2);
      if (textpips=="") textperc="";
      textname=StringConcatenate(textnames, symbol[i], "Percent", DoubleToStr(xdistt+ydistt, 0) );
      drawLabel(textname, textperc, 9, "Courier New", statcolor (profit), 0, xdist, ydist); 

      ydist=ydist+12; 
   }
   int lineypos;
   
   textname=StringConcatenate(textnames, symbol[i], "totalProfit", DoubleToStr(xdistt+ydistt, 0) );
   drawLabel(textname, DoubleToStr(MathAbs(totalprofit),2), 9, "Courier New", statcolor (totalprofit), 0, xdist-50, ydist);
 
   textname=StringConcatenate(textnames, symbol[i], "totalpips", DoubleToStr(xdistt+ydistt, 0) );
   drawLabel(textname, DoubleToStr(MathAbs(totalpips),0), 9, "Courier New", statcolor (totalpips), 0, xdist-90, ydist);
 
   string Spreadtxt=StringConcatenate("Total Spread = ", DoubleToStr(spreadpips,0), " (", DoubleToStr(spreadcurr,2), ")" );
   textname=StringConcatenate(textnames, symbol[i], "spreadtotal");
   drawLabel(textname, Spreadtxt, 10, "Courier New", Yellow, 0, 10, ydist+25); 
 
   if (Simulation==1) lineypos=ydist-(15*12+1); else lineypos=ydist-(8*12+1);
   textname=StringConcatenate(textnames, "Line1", DoubleToStr(xdistt, 0) );
   drawLabel(textname, "______________________________", 9, "Courier New", Silver, 0, xdistt, lineypos);   
 
   lineypos=lineypos+12*2;
   textname=StringConcatenate(textnames, "Line2", DoubleToStr(xdistt, 0) );
   drawLabel(textname, "______________________________", 9, "Courier New", Gainsboro, 0, xdistt, lineypos);
 
   lineypos=lineypos-12*4;
   textname=StringConcatenate(textnames, "Line3", DoubleToStr(xdistt, 0) );
   drawLabel(textname, "______________________________", 9, "Courier New", Gainsboro, 0, xdistt, lineypos);
}
//+------------------------------------------------------------------+ 
color statcolor (double total)
{
   if (total>0) return (LimeGreen);
   if (total<0) return (Tomato);
   return (Olive);
}
//+------------------------------------------------------------------+   
void drawLabel (string Ln, string Lt, int tz, string ts, color Lc, int cr, int xp, int yp)
{
   ObjectCreate(Ln, OBJ_LABEL, 0, 0, 0);
    ObjectSetText(Ln, Lt,tz, ts, Lc);
    ObjectSet(Ln, OBJPROP_CORNER, cr);
    ObjectSet(Ln, OBJPROP_XDISTANCE, xp);
    ObjectSet(Ln, OBJPROP_YDISTANCE, yp);  
}
//+------------------------------------------------------------------+   
void PercentChange (string title, int avgperiod, datetime timer, int ydist)
{
   string Sym, textname;
   double price1, price2, percent, avgpercent;
   int xdist=320, i, j, k, Shift;
 
   //if (Simulation==2) ydist=ydist-(14*12);
   if (Simulation==2) ydist=ydist+50;
 
   string cPairs[]={"GBPJPY", "GBPUSD", "EURJPY"};
   for (i=0;i<ArraySize(cPairs);i++)
   {
      Sym          =StringConcatenate(cPairs[i],suffix);
      Shift        =iBarShift(Sym, avgperiod, timer);
      k=0;
      avgpercent=0;

      for (j=0;j<Shift;j++)
      {
         price1       =iOpen(Sym, avgperiod, k);
         price2       =MarketInfo(Sym, MODE_BID);
         percent      =((price2-price1)/price1)*100;
         avgpercent   =avgpercent+percent;
         k++;
      }

      if (avgpercent!=0) avgpercent=avgpercent/k;

/*      textname=StringConcatenate("PercentSym-", cPairs[i] );
      drawLabel (textname, cPairs[i], 9, "Courier New", Gainsboro, 0, xdist, ydist);
  
      textname=StringConcatenate("PercentTitle", cPairs[i], DoubleToStr(ydist, 0) );
      drawLabel (textname, title, 9, "Courier New", Gainsboro, 0, 10, ydist+13);

      textname=StringConcatenate("Percent-", cPairs[i], DoubleToStr(ydist, 0) );
      drawLabel (textname, DoubleToStr(MathAbs(avgpercent),2), 9, "Courier New", statcolor(avgpercent), 0, xdist, ydist+13);
      xdist= xdist+ 60;  
*/   }
}

void sequence (int i, int j)
{
   string strTemp;
   double dblTemp;
   
   strTemp=symbol[i];
   symbol[i]=symbol[j];
   symbol[j]=strTemp;

   dblTemp=openbuy[i];
   openbuy[i]=openbuy[j];
   openbuy[j]=dblTemp;               

   dblTemp=closebuy[i];
   closebuy[i]=closebuy[j];
   closebuy[j]=dblTemp;               

   dblTemp=opensell[i];
   opensell[i]=opensell[j];
   opensell[j]=dblTemp;               

   dblTemp=closesell[i];
   closesell[i]=closesell[j];
   closesell[j]=dblTemp;          

   dblTemp=pipsbuy[i];
   pipsbuy[i]=pipsbuy[j];
   pipsbuy[j]=dblTemp;               

   dblTemp=pipssell[i];
   pipssell[i]=pipssell[j];
   pipssell[j]=dblTemp;               

   dblTemp=profitbuy[i];
   profitbuy[i]=profitbuy[j];
   profitbuy[j]=dblTemp;               

   dblTemp=profitsell[i];
   profitsell[i]=profitsell[j];
   profitsell[j]=dblTemp;      

   dblTemp=spread[i];
   spread[i]=spread[j];
   spread[j]=dblTemp;  
}

string StringUpperCase(string str)
{
   string   s = str;
   int      lenght = StringLen(str) - 1;
   int      char;
   
   while(lenght >= 0)
   {
      char = StringGetChar(s, lenght);
      if((char > 96 && char < 123) || (char > 223 && char < 256))
         s = StringSetChar(s, lenght, char - 32);
      else if(char > -33 && char < 0)
         s = StringSetChar(s, lenght, char + 224);
      lenght--;
   }
   return(s);
}